diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index c0ef84e18..93f52d515 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -7,7 +7,6 @@ import net.minecraft.client.entity.particle.ParticleDispatcher;
 import net.minecraft.client.gui.ScreenPhotoMode;
 import net.minecraft.client.gui.modelviewer.ScreenModelViewer;
 import net.minecraft.client.gui.options.ScreenOptions;
-import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.block.model.BlockModelLeaves;
 import net.minecraft.client.render.camera.EntityCamera;
@@ -18,7 +17,6 @@ import net.minecraft.client.render.terrain.ChunkRenderer;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.client.render.tileentity.TileEntityRenderer;
 import net.minecraft.client.render.worldtype.WorldTypeFX;
 import net.minecraft.client.render.worldtype.WorldTypeFXDispatcher;
 import net.minecraft.client.world.WorldClient;
@@ -66,57 +64,59 @@ public class RenderGlobal
         }
     }
     public static final int RENDER_CHUNK_SIZE = 16;
+    public static final int MAX_VISIBLE_REBUILDS_PER_FRAME = 2;
+    public static final int MAX_INVISIBLE_REBUILDS_PER_FRAME = 1;
     public static final int RENDER_LIST_BASE_WIDTH = 48;
 
-    public List<TileEntity> tileEntities;
-    private WorldClient worldObj;
+    public List<TileEntity> renderableTileEntities = new ArrayList<>();
+    private WorldClient world;
     private final TextureManager textureManager;
-    private final List<ChunkRenderer> chunkRenderersToUpdate;
+    private final List<ChunkRenderer> dirtyChunks = new ArrayList<>();
     private ChunkRenderer[] sortedChunkRenderers;
     private ChunkRenderer[] chunkRenderers;
-    private int renderChunksWide;
-    private int renderChunksTall;
-    private int renderChunksDeep;
-    private int glRenderListBase;
+    private int xChunks;
+    private int yChunks;
+    private int zChunks;
+    private int chunkLists;
     private final Minecraft mc;
-    private IntBuffer glOcclusionQueryBase;
-    private boolean occlusionEnabled;
+    private IntBuffer occlusionCheckIds;
+    private boolean occlusionCheck = false;
     private float lastCloudOffsetX = 0;
     private float lastCloudOffsetZ = 0;
-    private float cloudOffsetX;
-    private float cloudOffsetZ;
+    private float cloudOffsetX = 0;
+    private float cloudOffsetZ = 0;
     private float cloudVelocityX;
     private float cloudVelocityZ;
-
-    private final int starGLCallList;
-    private final int glSkyList;
-    private int minBlockX;
-    private int minBlockY;
-    private int minBlockZ;
-    private int maxBlockX;
-    private int maxBlockY;
-    private int maxBlockZ;
+    private int ticks;
+    private final int starList;
+    private final int skyList;
+    private int xMinChunk;
+    private int yMinChunk;
+    private int zMinChunk;
+    private int xMaxChunk;
+    private int yMaxChunk;
+    private int zMaxChunk;
     private Integer renderDistance = null;
-    private int renderEntitiesStartupCounter;
-    private int countEntitiesTotal;
-    private int countEntitiesRendered;
-    private int countEntitiesHidden;
-    IntBuffer occlusionResult;
-    private int renderersLoaded;
-    private int renderersBeingClipped;
-    private int renderersBeingOccluded;
-    private int renderersBeingRendered;
-    private int renderersSkippingRenderPass;
-    private int worldRenderersCheckIndex;
-    private final List<ChunkRenderer> glRenderLists;
-    private final DisplayList[] allDisplayLists = {
+    private int noEntityRenderFrames = 2;
+    private int totalEntities;
+    private int renderedEntities;
+    private int culledEntities;
+    IntBuffer resultBuffer = GLAllocation.createDirectIntBuffer(64);
+    private int totalChunks;
+    private int offscreenChunks;
+    private int occludedChunks;
+    private int renderedChunks;
+    private int emptyChunks;
+    private int chunkFixOffs;
+    private final List<ChunkRenderer> renderChunks = new ArrayList<>();
+    private final DisplayList[] renderLists = {
         new DisplayList(), new DisplayList(), new DisplayList(), new DisplayList()
     };
-    double prevSortX;
-    double prevSortY;
-    double prevSortZ;
-    public float damagePartialTime;
-    int frustumCheckOffset;
+    double xOld = -9999D;
+    double yOld = -9999D;
+    double zOld = -9999D;
+    public float destroyProgress;
+    int cullStep = 0;
 
     private double auroraBrightness = 0.0f;
     private double targetAuroraBrightness = Double.NaN;
@@ -126,54 +126,43 @@ public class RenderGlobal
     private double targetRainbowBrightness = Double.NaN;
     private double rainbowBrightnessDelta = Double.NaN;
 
-    public RenderGlobal(Minecraft minecraft, TextureManager textureManager)
+    public RenderGlobal(Minecraft mc, TextureManager textureManager)
     {
-        tileEntities = new ArrayList<>();
-        chunkRenderersToUpdate = new ArrayList<>();
-        occlusionEnabled = false;
-        cloudOffsetX = 0;
-        renderEntitiesStartupCounter = 2;
-        occlusionResult = GLAllocation.createDirectIntBuffer(64);
-        glRenderLists = new ArrayList<>();
-        prevSortX = -9999D;
-        prevSortY = -9999D;
-        prevSortZ = -9999D;
-        frustumCheckOffset = 0;
-        mc = minecraft;
+        this.mc = mc;
         this.textureManager = textureManager;
-        glRenderListBase = GLAllocation.generateDisplayLists(RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH * 3);
-        occlusionEnabled = OpenGLHelper.enableOcclusionCheck;
-        if(occlusionEnabled)
+        chunkLists = GLAllocation.generateDisplayLists(RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH * MAX_VISIBLE_REBUILDS_PER_FRAME);
+        occlusionCheck = OpenGLHelper.enableOcclusionCheck;
+        if(occlusionCheck)
         {
-            occlusionResult.clear();
-            glOcclusionQueryBase = GLAllocation.createDirectIntBuffer(RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH);
-            glOcclusionQueryBase.clear();
-            glOcclusionQueryBase.position(0);
-            glOcclusionQueryBase.limit(RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH);
-            ARBOcclusionQuery.glGenQueriesARB(glOcclusionQueryBase);
+            resultBuffer.clear();
+            occlusionCheckIds = GLAllocation.createDirectIntBuffer(RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH);
+            occlusionCheckIds.clear();
+            occlusionCheckIds.position(0);
+            occlusionCheckIds.limit(RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH);
+            ARBOcclusionQuery.glGenQueriesARB(occlusionCheckIds);
         }
 
         // Set up call list for stars
-        starGLCallList = GLAllocation.generateDisplayLists(3);
+        starList = GLAllocation.generateDisplayLists(3);
         updateStars();
 
         // Set up call list for sky
-        Tessellator tessellator = Tessellator.instance;
-        glSkyList = starGLCallList + 1;
-        GL11.glNewList(glSkyList, GL11.GL_COMPILE);
-        byte byte1 = 64;
-        int i = 256 / byte1 + 2;
-        float y = 16F;
-        for(int x = -byte1 * i; x <= byte1 * i; x += byte1)
+        Tessellator t = Tessellator.instance;
+        skyList = starList + 1;
+        GL11.glNewList(skyList, GL11.GL_COMPILE);
+        int s = 64;
+        int d = 256 / s + 2;
+        float yy = 16F;
+        for(int xx = -s * d; xx <= s * d; xx += s)
         {
-            for(int z = -byte1 * i; z <= byte1 * i; z += byte1)
+            for(int zz = -s * d; zz <= s * d; zz += s)
             {
-                tessellator.startDrawingQuads();
-                tessellator.addVertex(x, y, z);
-                tessellator.addVertex(x + byte1, y, z);
-                tessellator.addVertex(x + byte1, y, z + byte1);
-                tessellator.addVertex(x, y, z + byte1);
-                tessellator.draw();
+                t.startDrawingQuads();
+                t.addVertex(xx, yy, zz);
+                t.addVertex(xx + s, yy, zz);
+                t.addVertex(xx + s, yy, zz + s);
+                t.addVertex(xx, yy, zz + s);
+                t.draw();
             }
         }
         GL11.glEndList();
@@ -181,13 +170,13 @@ public class RenderGlobal
 
     public void updateStars() {
         GL11.glPushMatrix();
-        GL11.glNewList(starGLCallList, GL11.GL_COMPILE);
-        setupStarsCallList();
+        GL11.glNewList(starList, GL11.GL_COMPILE);
+        renderStars();
         GL11.glEndList();
         GL11.glPopMatrix();
     }
 
-    private void setupStarsCallList()
+    private void renderStars()
     {
         Random random = new Random(10842L);
         Random colorRandom = new Random(10842L); // Created a second random so the new color don't change the positions of the stars
@@ -242,36 +231,36 @@ public class RenderGlobal
         tessellator.draw();
     }
 
-    public void changeWorld(final WorldClient world)
+    public void setWorld(final WorldClient world)
     {
-        if(this.worldObj != null)
+        if(this.world != null)
         {
-            this.worldObj.removeListener(this);
+            this.world.removeListener(this);
         }
-        this.prevSortX = -9999D;
-        this.prevSortY = -9999D;
-        this.prevSortZ = -9999D;
-        this.worldObj = world;
+        this.xOld = -9999D;
+        this.yOld = -9999D;
+        this.zOld = -9999D;
+        this.world = world;
         this.auroraBrightness = 0.0f;
         this.targetAuroraBrightness = Float.NaN;
         if(world != null)
         {
             world.addListener(this);
-            loadRenderers();
+            allChanged();
         }
     }
-    public void loadRenderers()
+    public void allChanged()
     {
         ScreenOptions.queueReload = false;
         updateStars();
         // Delete all display lists - this is a (hopefully temporary) workaround to AMD's OpenGL driver leaking memory
         // See https://community.amd.com/t5/opengl-vulkan/high-vram-consumption-in-minecraft/m-p/607299
-        deleteRenderListBase();
-        glRenderListBase = GLAllocation.generateDisplayLists(RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH * 3);
+        deleteChunkLists();
+        chunkLists = GLAllocation.generateDisplayLists(RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH * MAX_VISIBLE_REBUILDS_PER_FRAME);
 
         BlockModelLeaves.setGraphicsLevel(mc.gameSettings.fancyGraphics.value == 1);
         renderDistance = mc.gameSettings.renderDistance.value;
-        if (worldObj == null) return;
+        if (world == null) return;
 
         // Reset all world renderers
         if(chunkRenderers != null)
@@ -281,76 +270,83 @@ public class RenderGlobal
                 chunkRenderer.delete();
             }
         }
-        int renderDiameterBlocks = renderDistance * 16 * 2;
-		renderChunksWide = renderDiameterBlocks / RENDER_CHUNK_SIZE + 1;
-        renderChunksTall = worldObj.getHeightBlocks() / RENDER_CHUNK_SIZE;
-		renderChunksDeep =  renderDiameterBlocks / RENDER_CHUNK_SIZE + 1;
-        chunkRenderers = new ChunkRenderer[renderChunksWide * renderChunksTall * renderChunksDeep];
-        sortedChunkRenderers = new ChunkRenderer[renderChunksWide * renderChunksTall * renderChunksDeep];
-        int renderListOffset = 0;
-        int chunkIndex = 0;
-        minBlockX = 0;
-        minBlockY = 0;
-        minBlockZ = 0;
-        maxBlockX = renderChunksWide;
-        maxBlockY = renderChunksTall;
-        maxBlockZ = renderChunksDeep;
-        for (ChunkRenderer cr : chunkRenderersToUpdate)
+        int dist = renderDistance * 16 * 2;
+
+		xChunks = dist / RENDER_CHUNK_SIZE + 1;
+        yChunks = world.getHeightBlocks() / RENDER_CHUNK_SIZE;
+		zChunks =  dist / RENDER_CHUNK_SIZE + 1;
+
+        chunkRenderers = new ChunkRenderer[xChunks * yChunks * zChunks];
+        sortedChunkRenderers = new ChunkRenderer[xChunks * yChunks * zChunks];
+
+        int id = 0;
+        int count = 0;
+
+        xMinChunk = 0;
+        yMinChunk = 0;
+        zMinChunk = 0;
+        xMaxChunk = xChunks;
+        yMaxChunk = yChunks;
+        zMaxChunk = zChunks;
+
+        for (ChunkRenderer cr : dirtyChunks)
         {
             cr.dirty = false;
         }
 
-        chunkRenderersToUpdate.clear();
-        tileEntities.clear();
-        for(int x = 0; x < renderChunksWide; x++)
+        dirtyChunks.clear();
+        renderableTileEntities.clear();
+
+        for(int x = 0; x < xChunks; x++)
         {
-            for(int y = 0; y < renderChunksTall; y++)
+            for(int y = 0; y < yChunks; y++)
             {
-                for(int z = 0; z < renderChunksDeep; z++)
+                for(int z = 0; z < zChunks; z++)
                 {
-                    int index = (z * renderChunksTall + y) * renderChunksWide + x;
-                    chunkRenderers[index] = mc.terrainRenderer.createChunkRenderer(worldObj, tileEntities, x * RENDER_CHUNK_SIZE, y * RENDER_CHUNK_SIZE, z * RENDER_CHUNK_SIZE, RENDER_CHUNK_SIZE, glRenderListBase + renderListOffset);
-                    if(occlusionEnabled)
+                    int index = (z * yChunks + y) * xChunks + x;
+                    chunkRenderers[index] = mc.terrainRenderer.createChunkRenderer(world, renderableTileEntities, x * RENDER_CHUNK_SIZE, y * RENDER_CHUNK_SIZE, z * RENDER_CHUNK_SIZE, RENDER_CHUNK_SIZE, chunkLists + id);
+                    if(occlusionCheck)
                     {
-                        chunkRenderers[index].occlusionId = glOcclusionQueryBase.get(chunkIndex);
+                        chunkRenderers[index].occlusionId = occlusionCheckIds.get(count);
                     }
                     chunkRenderers[index].occlusionQuerying = false;
                     chunkRenderers[index].occlusionVisible = true;
                     chunkRenderers[index].visible = true;
-                    chunkRenderers[index].id = chunkIndex++;
+                    chunkRenderers[index].id = count++;
                     chunkRenderers[index].setDirty();
                     sortedChunkRenderers[index] = chunkRenderers[index];
-                    chunkRenderersToUpdate.add(chunkRenderers[index]);
-                    renderListOffset += ChunkRenderer.MAX_RENDER_PASSES + 1;
+                    dirtyChunks.add(chunkRenderers[index]);
+                    id += ChunkRenderer.MAX_RENDER_PASSES + 1;
                 }
 
             }
 
         }
 
-        if(worldObj != null)
+        if(world != null)
         {
             if (mc.activeCamera != null)
             {
-                markRenderersForNewPosition(MathHelper.floor(mc.activeCamera.getX()), MathHelper.floor(mc.activeCamera.getY()), MathHelper.floor(mc.activeCamera.getZ()));
+                resortChunks(MathHelper.floor(mc.activeCamera.getX()), MathHelper.floor(mc.activeCamera.getY()), MathHelper.floor(mc.activeCamera.getZ()));
                 Arrays.sort(sortedChunkRenderers, new CameraSorter(mc.activeCamera));
             }
         }
-        renderEntitiesStartupCounter = 2;
+
+        noEntityRenderFrames = 2;
     }
 
     public void renderAurora(ICamera camera, float partialTick)
     {
-        float celestialAngle = worldObj.getCelestialAngle(partialTick);
+        float celestialAngle = world.getCelestialAngle(partialTick);
         if (celestialAngle < 0.25f) return;
 
         double cameraX = camera.getX(partialTick);
         double cameraY = camera.getY(partialTick);
         double cameraZ = camera.getZ(partialTick);
         double cameraYaw = camera.getYRot(partialTick);
-        double temperature = worldObj.getBlockTemperature((int)cameraX, (int)cameraZ);
+        double temperature = world.getBlockTemperature((int)cameraX, (int)cameraZ);
         float mult = 0.0f;
-        if ((temperature <= 0.4f || worldObj.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER_ENDLESS) && worldObj.isChunkLoaded((int)cameraX, (int)cameraZ))
+        if ((temperature <= 0.4f || world.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER_ENDLESS) && world.isChunkLoaded((int)cameraX, (int)cameraZ))
         {
             // temperature from 0.0f to 0.4f
             temperature /= 0.4f;
@@ -360,8 +356,8 @@ public class RenderGlobal
             mult += temperature;
         }
 
-        double altitude = worldObj.getWorldType().getYPercentage((int)cameraY);
-        if ((temperature <= 0.6f || worldObj.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER || worldObj.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER_ENDLESS) && altitude >= 0.8f)
+        double altitude = world.getWorldType().getYPercentage((int)cameraY);
+        if ((temperature <= 0.6f || world.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER || world.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER_ENDLESS) && altitude >= 0.8f)
         {
             // altitude from 0.8f to 1.0f
             altitude -= 0.8f;
@@ -392,18 +388,18 @@ public class RenderGlobal
         GL11.glDisable(GL11.GL_ALPHA_TEST);
 
         final double scale = 1f;
-        double auroraY = (worldObj.getWorldType().getMinY() + worldObj.getWorldType().getYRange() + 64f) * 2f;
+        double auroraY = (world.getWorldType().getMinY() + world.getWorldType().getYRange() + 64f) * 2f;
 
         // Draw pieces
         double rotationX = Math.cos(((cameraYaw * Math.PI) / 180D));
         double rotationZ = Math.sin(((cameraYaw * Math.PI) / 180D));
 
         textureManager.bindTexture(textureManager.loadTexture("/assets/minecraft/textures/environment/aurora.png"));
-        double time = worldObj.getWorldTime() + partialTick;
-        AuroraProvider aurora = worldObj.auroraProvider;
+        double time = world.getWorldTime() + partialTick;
+        AuroraProvider aurora = world.auroraProvider;
 
         double radius = 512;
-        long worldTime = worldObj.getWorldTime();
+        long worldTime = world.getWorldTime();
 
         Tessellator.instance.startDrawingQuads();
         for (double x = -radius; x < radius; x += 8f)
@@ -455,30 +451,30 @@ public class RenderGlobal
 
     public void renderEntities(ICamera camera, float partialTick)
     {
-        if(renderEntitiesStartupCounter > 0)
+        if(noEntityRenderFrames > 0)
         {
-            renderEntitiesStartupCounter--;
+            noEntityRenderFrames--;
             return;
         }
-        TileEntityRenderDispatcher.instance.cacheActiveRenderInfo(worldObj, camera, partialTick);
-        EntityRenderDispatcher.instance.cacheActiveRenderInfo(worldObj, camera, partialTick);
-        countEntitiesTotal = 0;
-        countEntitiesRendered = 0;
-        countEntitiesHidden = 0;
+        TileEntityRenderDispatcher.instance.cacheActiveRenderInfo(world, camera, partialTick);
+        EntityRenderDispatcher.instance.cacheActiveRenderInfo(world, camera, partialTick);
+        totalEntities = 0;
+        renderedEntities = 0;
+        culledEntities = 0;
         EntityRenderDispatcher.renderPosX = camera.getX(partialTick);
         EntityRenderDispatcher.renderPosY = camera.getY(partialTick);
         EntityRenderDispatcher.renderPosZ = camera.getZ(partialTick);
         TileEntityRenderDispatcher.renderPosX = camera.getX(partialTick);
         TileEntityRenderDispatcher.renderPosY = camera.getY(partialTick);
         TileEntityRenderDispatcher.renderPosZ = camera.getZ(partialTick);
-        List<Entity> loadedEntities = worldObj.getLoadedEntityList();
-        countEntitiesTotal = loadedEntities.size();
+        List<Entity> loadedEntities = world.getLoadedEntityList();
+        totalEntities = loadedEntities.size();
         Tessellator tessellator = Tessellator.instance;
         // Render weather effects
-        for (int i = 0; i < worldObj.weatherEffects.size(); i++)
+        for (int i = 0; i < world.weatherEffects.size(); i++)
         {
-            Entity entity = worldObj.weatherEffects.get(i);
-            countEntitiesRendered++;
+            Entity entity = world.weatherEffects.get(i);
+            renderedEntities++;
             if(entity.shouldRender(camera.getPosition(partialTick), 1) || mc.thePlayer.vehicle == entity)
             {
                 EntityRenderDispatcher.instance.renderEntity(tessellator, entity, partialTick);
@@ -505,100 +501,110 @@ public class RenderGlobal
             {
                 floorY = 0;
             }
-            if(floorY >= worldObj.getHeightBlocks())
+            if(floorY >= world.getHeightBlocks())
             {
-                floorY = worldObj.getHeightBlocks() - 1;
+                floorY = world.getHeightBlocks() - 1;
 
             }
-            if (worldObj.isBlockLoaded(MathHelper.floor(entity.x), floorY, MathHelper.floor(entity.z)) || mc.thePlayer.vehicle == entity)
+            if (world.isBlockLoaded(MathHelper.floor(entity.x), floorY, MathHelper.floor(entity.z)) || mc.thePlayer.vehicle == entity)
             {
-                countEntitiesRendered++;
+                renderedEntities++;
                 EntityRenderDispatcher.instance.renderEntity(tessellator, entity, partialTick);
             }
         }
 
-        for (int i = 0, tileEntitiesSize = tileEntities.size(); i < tileEntitiesSize; i++) {
-            TileEntity tileEntity = tileEntities.get(i);
+        for (int i = 0, tileEntitiesSize = renderableTileEntities.size(); i < tileEntitiesSize; i++) {
+            TileEntity tileEntity = renderableTileEntities.get(i);
             TileEntityRenderDispatcher.instance.renderTileEntity(tessellator, camera, tileEntity, partialTick);
         }
     }
 
     public String getRendererDebugInfo()
     {
-        return "C: " + renderersBeingRendered + "/" + renderersLoaded + ". F: " + renderersBeingClipped + ", O: " + renderersBeingOccluded + ", E: " + renderersSkippingRenderPass;
+        return "C: " + renderedChunks + "/" + totalChunks + ". F: " + offscreenChunks + ", O: " + occludedChunks + ", E: " + emptyChunks;
     }
 
     public String getEntityDebugInfo()
     {
-        return "E: " + countEntitiesRendered + "/" + countEntitiesTotal + ". B: " + countEntitiesHidden + ", I: " + (countEntitiesTotal - countEntitiesHidden - countEntitiesRendered);
+        return "E: " + renderedEntities + "/" + totalEntities + ". B: " + culledEntities + ", I: " + (totalEntities - culledEntities - renderedEntities);
     }
 
-    public void markRenderersForNewPosition(int x, int y, int z)
+    public void resortChunks(int xc, int yc, int zc)
     {
-        x -= 8;
-//        y -= 8;
-        z -= 8;
-        minBlockX = Integer.MAX_VALUE;
-        minBlockY = Integer.MAX_VALUE;
-        minBlockZ = Integer.MAX_VALUE;
-        maxBlockX = Integer.MIN_VALUE;
-        maxBlockY = Integer.MIN_VALUE;
-        maxBlockZ = Integer.MIN_VALUE;
-        int l = renderChunksWide * RENDER_CHUNK_SIZE;
-        int i1 = l / 2;
-        for(int j1 = 0; j1 < renderChunksWide; j1++)
+        xc -= 8;
+//        yc -= 8;
+        zc -= 8;
+
+        xMinChunk = Integer.MAX_VALUE;
+        yMinChunk = Integer.MAX_VALUE;
+        zMinChunk = Integer.MAX_VALUE;
+        xMaxChunk = Integer.MIN_VALUE;
+        yMaxChunk = Integer.MIN_VALUE;
+        zMaxChunk = Integer.MIN_VALUE;
+
+        int s2 = xChunks * RENDER_CHUNK_SIZE;
+        int s1 = s2 / 2;
+
+        for(int x = 0; x < xChunks; x++)
         {
-            int k1 = j1 * RENDER_CHUNK_SIZE;
-            int l1 = (k1 + i1) - x;
-            if(l1 < 0)
+            int xx = x * RENDER_CHUNK_SIZE;
+            int xOff = (xx + s1) - xc;
+            if(xOff < 0)
             {
-                l1 -= l - 1;
+                xOff -= s2 - 1;
             }
-            l1 /= l;
-            k1 -= l1 * l;
-            if(k1 < minBlockX)
+
+            xOff /= s2;
+            xx -= xOff * s2;
+            if(xx < xMinChunk)
             {
-                minBlockX = k1;
+                xMinChunk = xx;
             }
-            if(k1 > maxBlockX)
+
+            if(xx > xMaxChunk)
             {
-                maxBlockX = k1;
+                xMaxChunk = xx;
             }
-            for(int i2 = 0; i2 < renderChunksDeep; i2++)
+
+            for(int z = 0; z < zChunks; z++)
             {
-                int j2 = i2 * RENDER_CHUNK_SIZE;
-                int k2 = (j2 + i1) - z;
-                if(k2 < 0)
+                int zz = z * RENDER_CHUNK_SIZE;
+                int zOff = (zz + s1) - zc;
+                if(zOff < 0)
                 {
-                    k2 -= l - 1;
+                    zOff -= s2 - 1;
                 }
-                k2 /= l;
-                j2 -= k2 * l;
-                if(j2 < minBlockZ)
+
+                zOff /= s2;
+                zz -= zOff * s2;
+                if(zz < zMinChunk)
                 {
-                    minBlockZ = j2;
+                    zMinChunk = zz;
                 }
-                if(j2 > maxBlockZ)
+
+                if(zz > zMaxChunk)
                 {
-                    maxBlockZ = j2;
+                    zMaxChunk = zz;
                 }
-                for(int l2 = 0; l2 < renderChunksTall; l2++)
+
+                for(int y = 0; y < yChunks; y++)
                 {
-                    int i3 = l2 * RENDER_CHUNK_SIZE;
-                    if(i3 < minBlockY)
+                    int yy = y * RENDER_CHUNK_SIZE;
+                    if(yy < yMinChunk)
                     {
-                        minBlockY = i3;
+                        yMinChunk = yy;
                     }
-                    if(i3 > maxBlockY)
+                    if(yy > yMaxChunk)
                     {
-                        maxBlockY = i3;
+                        yMaxChunk = yy;
                     }
-                    ChunkRenderer worldrenderer = chunkRenderers[(i2 * renderChunksTall + l2) * renderChunksWide + j1];
-                    boolean flag = worldrenderer.dirty;
-                    worldrenderer.setPos(k1, i3, j2);
-                    if(!flag && worldrenderer.dirty)
+
+                    ChunkRenderer renderer = chunkRenderers[(z * yChunks + y) * xChunks + x];
+                    boolean wasDirty = renderer.dirty;
+                    renderer.setPos(xx, yy, zz);
+                    if(!wasDirty && renderer.dirty)
                     {
-                        chunkRenderersToUpdate.add(worldrenderer);
+                        dirtyChunks.add(renderer);
                     }
                 }
 
@@ -607,65 +613,68 @@ public class RenderGlobal
         }
 
     }
-    public int sortAndRender(ICamera camera, int renderPass, double partialTick)
+    public int render(ICamera camera, int renderPass, double partialTick)
     {
         // Find which renderers need updating
         for(int i = 0; i < 10; i++)
         {
-            worldRenderersCheckIndex = (worldRenderersCheckIndex + 1) % chunkRenderers.length;
-            ChunkRenderer chunkRenderer = chunkRenderers[worldRenderersCheckIndex];
-            if(chunkRenderer.dirty && !chunkRenderersToUpdate.contains(chunkRenderer))
+            chunkFixOffs = (chunkFixOffs + 1) % chunkRenderers.length;
+            ChunkRenderer chunkRenderer = chunkRenderers[chunkFixOffs];
+            if(chunkRenderer.dirty && !dirtyChunks.contains(chunkRenderer))
             {
-                chunkRenderersToUpdate.add(chunkRenderer);
+                dirtyChunks.add(chunkRenderer);
             }
         }
 
         if(mc.gameSettings.renderDistance.value != renderDistance)
         {
-            loadRenderers();
+            allChanged();
         }
+
         if(renderPass == 0)
         {
-            renderersLoaded = 0;
-            renderersBeingClipped = 0;
-            renderersBeingOccluded = 0;
-            renderersBeingRendered = 0;
-            renderersSkippingRenderPass = 0;
+            totalChunks = 0;
+            offscreenChunks = 0;
+            occludedChunks = 0;
+            renderedChunks = 0;
+            emptyChunks = 0;
         }
-        double entityPosX = camera.getX((float) partialTick);
-        double entityPosY = camera.getY((float) partialTick);
-        double entityPosZ = camera.getZ((float) partialTick);
-        double dPosX = camera.getX() - prevSortX;
-        double dPosY = camera.getY() - prevSortY;
-        double dPosZ = camera.getZ() - prevSortZ;
-        if(dPosX * dPosX + dPosY * dPosY + dPosZ * dPosZ > RENDER_CHUNK_SIZE)
+
+        double xOff = camera.getX((float) partialTick);
+        double yOff = camera.getY((float) partialTick);
+        double zOff = camera.getZ((float) partialTick);
+        double xd = camera.getX() - xOld;
+        double yd = camera.getY() - yOld;
+        double zd = camera.getZ() - zOld;
+        if(xd * xd + yd * yd + zd * zd > RENDER_CHUNK_SIZE)
         {
-            prevSortX = camera.getX();
-            prevSortY = camera.getY();
-            prevSortZ = camera.getZ();
-            markRenderersForNewPosition(MathHelper.floor(camera.getX()), MathHelper.floor(camera.getY()), MathHelper.floor(camera.getZ()));
+            xOld = camera.getX();
+            yOld = camera.getY();
+            zOld = camera.getZ();
+            resortChunks(MathHelper.floor(camera.getX()), MathHelper.floor(camera.getY()), MathHelper.floor(camera.getZ()));
             Arrays.sort(sortedChunkRenderers, new CameraSorter(camera));
         }
+
         Lighting.disable();
-        int k = 0;
-        if(occlusionEnabled && mc.gameSettings.advancedOpenGL.value && renderPass == 0)
+        int count = 0;
+        if(occlusionCheck && mc.gameSettings.advancedOpenGL.value && renderPass == 0)
         {
-            int min = 0;
-            int max = RENDER_CHUNK_SIZE;
-            checkOcclusionQueryResult(min, max);
-            for(int i = min; i < max; i++)
+            int from = 0;
+            int to = RENDER_CHUNK_SIZE;
+            checkQueryResults(from, to);
+            for(int i = from; i < to; i++)
             {
                 sortedChunkRenderers[i].occlusionVisible = true;
             }
 
-            k += renderSortedRenderers(min, max, renderPass, partialTick);
+            count += renderChunks(from, to, renderPass, partialTick);
             do
             {
-                int byte0 = max;
-                max *= 2;
-                if(max > sortedChunkRenderers.length)
+                from = to;
+                to *= 2;
+                if(to > sortedChunkRenderers.length)
                 {
-                    max = sortedChunkRenderers.length;
+                    to = sortedChunkRenderers.length;
                 }
                 GL11.glDisable(GL11.GL_TEXTURE_2D);
                 GL11.glDisable(GL11.GL_LIGHTING);
